## ros-humble-gscam 2.0.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(gscam)

# System Dependencies
find_package(PkgConfig)

pkg_check_modules(GSTREAMER REQUIRED gstreamer-1.0)
pkg_check_modules(GST_APP REQUIRED gstreamer-app-1.0)

find_package(ament_cmake REQUIRED)
find_package(class_loader REQUIRED)
find_package(image_transport REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rclcpp_components REQUIRED)
find_package(sensor_msgs REQUIRED)
find_package(camera_calibration_parsers REQUIRED)
find_package(camera_info_manager REQUIRED)

include_directories(
  include
  ${GLIB_INCLUDE_DIRS}
  ${GST_APP_INCLUDE_DIRS})

add_library(gscam SHARED src/gscam.cpp)
target_link_libraries(gscam
  ${ament_LIBRARIES}
  ${GSTREAMER_LIBRARIES}
  ${GST_APP_LIBRARIES})
ament_target_dependencies(gscam
  "class_loader"
  "image_transport"
  "rclcpp"
  "rclcpp_components"
  "sensor_msgs"
  "camera_calibration_parsers"
  "camera_info_manager")

rclcpp_components_register_node(gscam
  PLUGIN "gscam::GSCam"
  EXECUTABLE gscam_node
)

set(node_plugins "${node_plugins}gscam::GSCam;$<TARGET_FILE:gscam>\n")

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()

  find_package(ament_cmake_gtest)
  ament_add_gtest(
    smoke_test
    test/smoke_test.cpp
    ENV GSCAM_CONFIG="videotestsrc pattern=snow ! capsfilter caps=video/x-raw,width=800,height=600 ! videoconvert"
  )
  if(TARGET smoke_test)
    target_link_libraries(smoke_test gscam)
  endif()
endif()

ament_export_dependencies(class_loader)

ament_export_include_directories(include)

ament_export_targets(export_gscam)

ament_export_libraries(gscam)

ament_package()

# Install directives

install(TARGETS gscam
  EXPORT export_gscam
  DESTINATION lib
)

install(
  DIRECTORY "examples"
  DESTINATION "share/${PROJECT_NAME}"
)

=== debian/changelog ===
ros-humble-gscam (2.0.2-1jammy) jammy; urgency=high

  * Update ROS2, Ubuntu and GStreamer versions (#85 <https://github.com/ros-drivers/gscam/issues/85>)
  * fix: ros2 gstreamer timestamps (#83 <https://github.com/ros-drivers/gscam/issues/83>)
    * fix: correct gstreamer timestamp offset calculation for image header timestamp
    * docs: add use_gst_timestamps parameter to the readme file
  * ci: update docker image for latest ros distribution (#81 <https://github.com/ros-drivers/gscam/issues/81>)
    * ci: update docker image of rolling
    * ci: add humble distribution
    * ci: add workaround for jammy
  * Contributors: Clyde McQueen, Daisuke Nishimatsu, David Wong

 -- Jonathan Bohren <jbo@jhu.edu>  Wed, 15 Jun 2022 15:00:00 -0000

ros-humble-gscam (2.0.1-1jammy) jammy; urgency=high

  * feat: add yuv support (#78 <https://github.com/ros-drivers/gscam/issues/78>)
    * feat: add yuv support
    * docs: add parameter description about image encodings
  * feat: add option to use sensor data qos (#79 <https://github.com/ros-drivers/gscam/issues/79>)
    * feat: add option to use sensor data qos
    * docs: add description about the new flag
  * Improve Dockerfile (#77 <https://github.com/ros-drivers/gscam/issues/77>)
    * Use COPY instead of git clone
    * Copy source into gscam
    Co-authored-by: Daisuke Nishimatsu <mailto:42202095+wep21@users.noreply.github.com>
    * Small fixes
    Co-authored-by: Daisuke Nishimatsu <mailto:42202095+wep21@users.noreply.github.com>
  * Merge pull request #76 <https://github.com/ros-drivers/gscam/issues/76> from clydemcqueen/ros2
    Fix uninitialized variable, adding more CI / test infrastructure.
  * Merge pull request #9 <https://github.com/ros-drivers/gscam/issues/9> from clydemcqueen/clyde_fixes
    Several fixes
  * feat: add Dockerfile
  * chore: support multiple CLion build envs
  * fix: initialize variable
  * Contributors: Clyde McQueen, Daisuke Nishimatsu, Jonathan Bohren

 -- Jonathan Bohren <jbo@jhu.edu>  Sun, 27 Feb 2022 15:00:00 -0000

ros-humble-gscam (2.0.0-1jammy) jammy; urgency=high

  * fix: fix test dependency in package.xml
  * Add note on testing and examples
  * Update README
  * chore: fix for uncrustify
  * fix: fix smoke test
  * chore: fix copyright
  * chore: fix flake8
  * chore: fix pep257
  * chore: fix lint_cmake
  * chore: fix cpplint
  * chore: change license
  * chore: apply uncrustify
  * chore: add linter dependencies
  * chore: simplify parameter declaration
  * adding explicit parameter types to string parameters
  * Add smoke test
  * Break deadlock for a clean exit
  * fix: fix legacy group namespace
  * chore: install examples directory
  * fix: fix launch extension
  * fix: fix launch executable name
  * feat: create node exe from rclcpp components
  * Update README
  * Remove extra files, rename .h to .hpp
  * Configure once, avoids re-declaring parameters
  * Port launch files to ros2
  * Remove support for gstreamer-0.10
  * Use Github Actions and ros-tooling for CI
  * Remove deprecation warnings, clean up includes
  * Fixed crash in GStreamer 1.16.2, works on Foxy
  * Minimal ROS2 port, works in Eloquent
  * Contributors: Clyde McQueen, Jonathan Bohren, wep21

 -- Jonathan Bohren <jbo@jhu.edu>  Sat, 12 Feb 2022 15:00:00 -0000

ros-humble-gscam (1.0.1-1jammy) jammy; urgency=high

  * Merge pull request #52 <https://github.com/ros-drivers/gscam/issues/52> from k-okada/add_travis
    update travis.yml
  * Update README.md
    gscam -> GSCam
  * update travis.yml
  * Merge pull request #40 <https://github.com/ros-drivers/gscam/issues/40> from ros-drivers/mikaelarguedas-patch-1
    update to use non deprecated pluginlib macro
  * update to use non deprecated pluginlib macro
  * Contributors: Kei Okada, Mikael Arguedas

 -- Jonathan Bohren <jbo@jhu.edu>  Wed, 05 Sep 2018 15:00:00 -0000

ros-humble-gscam (1.0.0-1jammy) jammy; urgency=high

  * Gstreamer 1 0 support (#36 <https://github.com/ros-drivers/gscam/issues/36> )
    * delete unused manifest.xml, rosdep.yaml
    * use libgstreamer1.0 for lunar
    * Fixing preproc switches so that the 1.0 branch still builds against 0.1 without the switch flags
    * Preliminary GStreamer-1.0 support see README for more info
  * Contributors: Jonathan Bohren, Kei Okada

 -- Jonathan Bohren <jbo@jhu.edu>  Mon, 12 Jun 2017 15:00:00 -0000

ros-humble-gscam (0.2.0-1jammy) jammy; urgency=high

  * add ROS Orphaned Package Maintainers to maintainer tag (#35 <https://github.com/ros-drivers/gscam/issues/35> )
  * gscam_nodelet.h: include scoped_ptr.hpp to compile with boost 1.57
    When compiling gscam with the currently latest boost version 1.57,
    it fails with:
    In file included from [...]/src/gscam_nodelet.cpp:5:0:
    [...]/include/gscam/gscam_nodelet.h:20:12: error: 'scoped_ptr' in namespace 'boost' does not name a template type
    boost::scoped_ptr<GSCam> gscam_driver_;
    ^
    [...]/include/gscam/gscam_nodelet.h:21:12: error: 'scoped_ptr' in namespace 'boost' does not name a template type
    boost::scoped_ptr<boost::thread> stream_thread_;
    ^
    It seems that the dependencies of boost/thread.hpp have changed
    and boost/scoped_ptr.hpp is not included anymore with
    boost/thread.hpp. Hence, the scoped_ptr is not defined in the
    gscam_nodelet header. After scanning quickly through the release
    notes of version 1.57, the boost bug tracker and a few changesets,
    I could not find not a hint what has changed in the thread library
    that gscam must include scoped_ptr itself.
    This commit simply addresses the compiler error by explicitly
    adding boost's scoped_ptr header in the gscam_nodelet header.
    As this commit also compiles with boost version 1.56, the commit
    is not expected to cause any problems with other build
    configurations.
    Signed-off-by: Lukas Bulwahn <lukas.bulwahn@oss.bmw-carit.de>
  * Remove dependency on opencv2 to fix under indigo
    Packages can no longer depend on opencv2 as of indigo.


=== debian/control ===
Source: ros-humble-gscam
Section: misc
Priority: optional
Maintainer: Jonathan Bohren <jbo@jhu.edu>
Build-Depends: debhelper (>= 9.0.0), libgstreamer-plugins-base1.0-dev, libgstreamer1.0-dev, ros-humble-ament-cmake, ros-humble-ament-cmake-gtest <!nocheck>, ros-humble-ament-lint-auto <!nocheck>, ros-humble-ament-lint-common <!nocheck>, ros-humble-camera-calibration-parsers, ros-humble-camera-info-manager, ros-humble-class-loader, ros-humble-cv-bridge, ros-humble-image-transport, ros-humble-rclcpp, ros-humble-rclcpp-components, ros-humble-sensor-msgs, ros-humble-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-humble-gscam
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libgstreamer-plugins-base1.0-dev, libgstreamer1.0-dev, ros-humble-camera-calibration-parsers, ros-humble-camera-info-manager, ros-humble-class-loader, ros-humble-cv-bridge, ros-humble-image-transport, ros-humble-rclcpp, ros-humble-rclcpp-components, ros-humble-sensor-msgs, ros-humble-ros-workspace
Description: A ROS camera driver that uses gstreamer to connect to devices such as webcams.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/humble/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/humble" \
		-DAMENT_PREFIX_PATH="/opt/ros/humble" \
		-DCMAKE_PREFIX_PATH="/opt/ros/humble" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-gscam//opt/ros/humble/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_install
